package nl.fampennings.sound;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.LinearLayout;

public class SoundActivity extends Activity {

    // References to the views
    LinearLayout mLinearLayout;
    Button       mButImpactOnce;
    Button       mButFluteOnce;
    Button       mButAnvilStart;
    
    // References to the sounds
    Sound        mSound;
    int          mSoundImpact;
    int          mSoundAnvil;
    int          mSoundFlute;

    // The listeners for the buttons
    OnClickListener mButImpactOnce_OnClickListener = new OnClickListener() {
        @Override public void onClick(View v) {
            mSound.play(mSoundImpact);
        }
    };

    OnClickListener mButFluteOnce_OnClickListener = new OnClickListener() {
        @Override public void onClick(View v) {
            mSound.play(mSoundFlute);
        }
    };

    int stop;
    
    OnClickListener mButAnvilStart_OnClickListener = new OnClickListener() {
        @Override public void onClick(View v) {
            // Play the sound continuously
            final int streamId=mSound.play(mSoundAnvil, -1, 0.5f );
            // Create a fresh button to stop this newly created sound
            final Button b= new Button(SoundActivity.this); 
            // The stop button should have a unique caption
            b.setText( "Stop anvil " + (++stop) ); 
            // A click on the stop button should stop the sound and remove the button
            b.setOnClickListener( new OnClickListener() {
                @Override public void onClick(View v) { 
                    mSound.stop(streamId); 
                    mLinearLayout.removeView(b); 
                }
            });
            // Finally, add the stop button to the linear layout view
            mLinearLayout.addView(b); 
        }
    };

    @Override public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);

        // Lookup the views
        mLinearLayout = (LinearLayout)findViewById(R.id.linearlayout);
        mButImpactOnce= (Button)findViewById(R.id.butimpactonce);
        mButFluteOnce = (Button)findViewById(R.id.butfluteonce);
        mButAnvilStart= (Button)findViewById(R.id.butanvilstart);

        // Set the listeners
        mButImpactOnce.setOnClickListener(mButImpactOnce_OnClickListener);
        mButFluteOnce .setOnClickListener(mButFluteOnce_OnClickListener);
        mButAnvilStart.setOnClickListener(mButAnvilStart_OnClickListener);
        
        // Add the sound fragments 
        mSound= new Sound(this,5);
        mSoundImpact = mSound.add(this, R.raw.impact);
        mSoundFlute  = mSound.add(this, R.raw.flute);
        mSoundAnvil  = mSound.add(this, R.raw.anvil);

    }
}

